package com.brilliance.isc.swift.objmtconvert.model.mt7xx;

import com.brilliance.isc.swift.objmtconvert.annotation.FieldDescription;
import com.brilliance.isc.swift.objmtconvert.annotation.Status;
import com.brilliance.isc.swift.objmtconvert.annotation.TagName;
import com.brilliance.isc.swift.objmtconvert.annotation.TagRegex;
import com.brilliance.isc.swift.objmtconvert.model.AbsMTCreator;
import com.brilliance.isc.swift.objmtconvert.model.AbsTagCreate;
import com.brilliance.isc.swift.objmtconvert.model.commontag.ActnoBicAdrTagXXX;
import com.brilliance.isc.swift.objmtconvert.model.commontag.DcDateCurAmtTagXXX;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.*;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag32BCreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag39ACreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag39CCreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag41aCreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag44ACreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag44CCreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag44DCreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag44ECreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag44FCreator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag50Creator;
import com.brilliance.isc.swift.objmtconvert.model.mt7xx.tag.tag707.Tag72ZCreator;
import com.brilliance.isc.swift.objmtconvert.result.MtResult;
import lombok.With;

import java.util.ArrayList;
import java.util.List;

/**
 * @author gaosheng
 * @date 2023/2/27
 */
public class MT707Creator extends AbsMTCreator {

    //27
    @Status("M")
    @TagName("27")
    @FieldDescription("Sequence of Total")
    @TagRegex("1!n/1!n")
    private String sequenceOfTotal;

    //20
    @Status("M")
    @TagName("20")
    @FieldDescription("Sender's Reference")
    @TagRegex("16x")
    private String sendersReference;

    //21
    @Status("M")
    @TagName("21")
    @FieldDescription("Receiver's Reference")
    @TagRegex("16x")
    private String receiversReference;

    //23
    @Status("M")
    @TagName("23")
    @FieldDescription("Issuing Bank's Reference")
    @TagRegex("16x")
    private String issuingBanksReference;

    //52a
    @Status("O")
    @TagName({"52A","52D"})
    @FieldDescription("Issuing Bank")
    @TagRegex({"[/1!a][/34x]<crlf>4!a2!a2!c[3!c],[/1!a][/34x]<crlf>4*35x"})
    private ActnoBicAdrTagXXX issuingBank;

    //50B
    @Status("O")
    @TagName("50B")
    @FieldDescription("Non-Bank Issuer")
    @TagRegex("4*35x")
    private String nonBankIssuer;

    //31C
    @Status("M")
    @TagName("31C")
    @FieldDescription("Date of Issue")
    @TagRegex("6!n")
    private String dateOfIssue;

    //26E
    @Status("M")
    @TagName("26E")
    @FieldDescription("Number of Amendment")
    @TagRegex("3n")
    private String numberOfAmendment;

    //30
    @Status("M")
    @TagName("30")
    @FieldDescription("Date of Amendment")
    @TagRegex("6!n")
    private String dateOfAmendment;

    //22A
    @Status("M")
    @TagName("22A")
    @FieldDescription("Purpose of Message")
    @TagRegex("4!c")
    private String purposeOfMessage;

    //23S
    @Status("O")
    @TagName("23S")
    @FieldDescription("Cancellation Requeste")
    @TagRegex("6!a")
    private String cancellationRequest;

    //40A
    @Status("O")
    @TagName("40A")
    @FieldDescription("Form of Documentary Credit")
    @TagRegex("24x")
    private String formOfDocumentaryCredit;

    //40E
    @Status("O")
    @TagName("40E")
    @FieldDescription("Applicable Rules")
    @TagRegex("30x[/35x]")
    private String applicableRules;

    //31D
    @Status("O")
    @TagName("31D")
    @FieldDescription("Date and Place of Expiry")
    @TagRegex("6!n29x")
    private String dateAndPlaceOfExpiry;

    //50
    @Status("O")
    @TagName("50")
    @FieldDescription("Changed Applicant Details")
    @TagRegex("4*35x")
    private String changedApplicantDetails;

    //59
    @Status("O")
    @TagName("59")
    @FieldDescription("Beneficiary")
    @TagRegex("[/34x]<crlf>4*35x")
    private ActnoBicAdrTagXXX beneficiary;

    //32B
    @Status("O")
    @TagName("32B")
    @FieldDescription("Increase of Documentary Credit Amount")
    @TagRegex("3!a15d")
    private DcDateCurAmtTagXXX increaseOfDocumentaryCreditAmount;

    //33B
    @Status("O")
    @TagName("33B")
    @FieldDescription("Decrease of Documentary Credit Amount")
    @TagRegex("3!a15d")
    private DcDateCurAmtTagXXX decreaseOfDocumentaryCreditAmount;

    //39A
    @Status("O")
    @TagName("39A")
    @FieldDescription("Percentage Credit Amount Tolerance")
    @TagRegex("2n/2n")
    private String percentageCreditAmountTolerance;

    //39C
    @Status("O")
    @TagName("39C")
    @FieldDescription("Additional Amounts Covered")
    @TagRegex("4*35x")
    private String additionalAmountsCovered;

    //41a
    @Status("O")
    @TagName({"41A","41D"})
    @FieldDescription("Available With ... By ...")
    @TagRegex({"4!a2!a2!c[3!c]<crlf>14x","4*35x<crlf>14x"})
    private ActnoBicAdrTagXXX availableWithBy;

    //42C
    @Status("O")
    @TagName("42C")
    @FieldDescription("Drafts at ...")
    @TagRegex("3*35x")
    private String draftsAt;

    //42a
    @Status("O")
    @TagName({"42A","42D"})
    @FieldDescription("Drawee")
    @TagRegex({"[/1!a][/34x]<crlf>4!a2!a2!c[3!c]","[/1!a][/34x]<crlf>4*35x"})
    private ActnoBicAdrTagXXX drawee;

    //42M
    @Status("O")
    @TagName("42M")
    @FieldDescription("Mixed Payment Details")
    @TagRegex("4*35x")
    private String mixedPaymentDetails;

    //42P
    @Status("O")
    @TagName("42P")
    @FieldDescription("Negotiation/Deferred Payment Details")
    @TagRegex("4*35x")
    private String negotiationDeferredPaymentDetails;

    //43P
    @Status("O")
    @TagName("43P")
    @FieldDescription("Partial Shipments")
    @TagRegex("11x")
    private String partialShipments;

    //43T
    @Status("O")
    @TagName("43T")
    @FieldDescription("Transhipment")
    @TagRegex("11x")
    private String transhipment;

    //44A
    @Status("O")
    @TagName("44A")
    @FieldDescription("Place of Taking in Charge/Dispatch from .../Place of Receipt")
    @TagRegex("65x")
    private String placeOfTakingInChargeDFPOR;

    //44E
    @Status("O")
    @TagName("44E")
    @FieldDescription("Port of Loading/Airport of Departure")
    @TagRegex("65x")
    private String portOfLoadingAOD;

    //44F
    @Status("O")
    @TagName("44F")
    @FieldDescription("Port of Discharge/Airport of Destination")
    @TagRegex("65x")
    private String portOfDischargeAOD;

    //44B
    @Status("O")
    @TagName("44B")
    @FieldDescription("Place of Final Destination/For Transportation to .../Place of Delivery")
    @TagRegex("65x")
    private String placeOfFinalDestinationFTTPOD;

    //44C
    @Status("O")
    @TagName("44C")
    @FieldDescription("Latest Date of Shipment")
    @TagRegex("6!n")
    private String latestDateOfShipment;

    //44D
    @Status("O")
    @TagName("44D")
    @FieldDescription("Shipment Period")
    @TagRegex("6*65x")
    private String shipmentPeriod;

    //45B
    @Status("O")
    @TagName("45B")
    @FieldDescription("Description of Goods and/or Services")
    @TagRegex("100*65z")
    private String descriptionOfGoodsAndOS;

    //46B
    @Status("O")
    @TagName("46B")
    @FieldDescription("Documents Required")
    @TagRegex("100*65z")
    private String documentsRequired;

    //47B
    @Status("O")
    @TagName("47B")
    @FieldDescription("Additional Conditions")
    @TagRegex("100*65z")
    private String additionalConditions;

    //49M
    @Status("O")
    @TagName("49M")
    @FieldDescription("Special Payment Conditions for Beneficiary")
    @TagRegex("100*65z")
    private String specialPaymentConditionsForBeneficiary;

    //49N
    @Status("O")
    @TagName("49N")
    @FieldDescription("Special Payment Conditions for Bank Only")
    @TagRegex("100*65z")
    private String specialPaymentConditionsForBankOnly;

    //71D
    @Status("O")
    @TagName("71D")
    @FieldDescription("Charges")
    @TagRegex("6*35z")
    private String charges;

    //71N
    @Status("O")
    @TagName("71N")
    @FieldDescription("Amendment Charge Payable By")
    @TagRegex("4!c<crlf>[6*35z]")
    private ActnoBicAdrTagXXX amendmentChargePayableBy;

    //48
    @Status("O")
    @TagName("48")
    @FieldDescription("Period for Presentation in Days")
    @TagRegex("3n[/35x]")
    private String periodForPresentationInDays;

    //49
    @Status("O")
    @TagName("49")
    @FieldDescription("Confirmation Instructions")
    @TagRegex("7!x")
    private String confirmationInstructions;

    //58a
    @Status("O")
    @TagName({"58A","58D"})
    @FieldDescription("Requested Confirmation Party")
    @TagRegex({"[/1!a][/34x]<crlf>4!a2!a2!c[3!c]","[/1!a][/34x]<crlf>4*35x"})
    private ActnoBicAdrTagXXX requestedConfirmationParty;

    //53a
    @Status("O")
    @TagName({"53A","53D"})
    @FieldDescription("Reimbursing Bank")
    @TagRegex({"[/1!a][/34x]<crlf>4!a2!a2!c[3!c]","[/1!a][/34x]<crlf>4*35x"})
    private ActnoBicAdrTagXXX reimbursingBank;

    //78
    @Status("O")
    @TagName("78")
    @FieldDescription("Instructions to the Paying/Accepting/Negotiating Bank")
    @TagRegex("12*65x")
    private String instructionsToThePayingANB;

    //57a
    @Status("O")
    @TagName({"57A","57B","57D"})
    @FieldDescription("'Advise Through' Bank")
    @TagRegex({"[/1!a][/34x]<crlf>4!a2!a2!c[3!c]","[/1!a][/34x]<crlf>[35x]","[/1!a][/34x]<crlf>4*35x"})
    private ActnoBicAdrTagXXX adviseThroughBank;

    //72Z
    @Status("O")
    @TagName("72Z")
    @FieldDescription("Sender to Receiver Information")
    @TagRegex("6*35z")
    private String senderToReceiverInformation;

    public String getSequenceOfTotal() {
        return sequenceOfTotal;
    }

    public void setSequenceOfTotal(String sequenceOfTotal) {
        this.sequenceOfTotal = sequenceOfTotal;
    }

    public String getSendersReference() {
        return sendersReference;
    }

    public void setSendersReference(String sendersReference) {
        this.sendersReference = sendersReference;
    }

    public String getReceiversReference() {
        return receiversReference;
    }

    public void setReceiversReference(String receiversReference) {
        this.receiversReference = receiversReference;
    }

    public String getIssuingBanksReference() {
        return issuingBanksReference;
    }

    public void setIssuingBanksReference(String issuingBanksReference) {
        this.issuingBanksReference = issuingBanksReference;
    }



    public String getNonBankIssuer() {
        return nonBankIssuer;
    }

    public void setNonBankIssuer(String nonBankIssuer) {
        this.nonBankIssuer = nonBankIssuer;
    }

    public String getDateOfIssue() {
        return dateOfIssue;
    }

    public void setDateOfIssue(String dateOfIssue) {
        this.dateOfIssue = dateOfIssue;
    }

    public String getNumberOfAmendment() {
        return numberOfAmendment;
    }

    public void setNumberOfAmendment(String numberOfAmendment) {
        this.numberOfAmendment = numberOfAmendment;
    }

    public String getDateOfAmendment() {
        return dateOfAmendment;
    }

    public void setDateOfAmendment(String dateOfAmendment) {
        this.dateOfAmendment = dateOfAmendment;
    }

    public String getPurposeOfMessage() {
        return purposeOfMessage;
    }

    public void setPurposeOfMessage(String purposeOfMessage) {
        this.purposeOfMessage = purposeOfMessage;
    }

    public String getCancellationRequest() {
        return cancellationRequest;
    }

    public void setCancellationRequest(String cancellationRequest) {
        this.cancellationRequest = cancellationRequest;
    }

    public String getFormOfDocumentaryCredit() {
        return formOfDocumentaryCredit;
    }

    public void setFormOfDocumentaryCredit(String formOfDocumentaryCredit) {
        this.formOfDocumentaryCredit = formOfDocumentaryCredit;
    }

    public String getApplicableRules() {
        return applicableRules;
    }

    public void setApplicableRules(String applicableRules) {
        this.applicableRules = applicableRules;
    }

    public String getDateAndPlaceOfExpiry() {
        return dateAndPlaceOfExpiry;
    }

    public void setDateAndPlaceOfExpiry(String dateAndPlaceOfExpiry) {
        this.dateAndPlaceOfExpiry = dateAndPlaceOfExpiry;
    }

    public String getChangedApplicantDetails() {
        return changedApplicantDetails;
    }

    public void setChangedApplicantDetails(String changedApplicantDetails) {
        this.changedApplicantDetails = changedApplicantDetails;
    }


    public String getPercentageCreditAmountTolerance() {
        return percentageCreditAmountTolerance;
    }

    public void setPercentageCreditAmountTolerance(String percentageCreditAmountTolerance) {
        this.percentageCreditAmountTolerance = percentageCreditAmountTolerance;
    }

    public String getAdditionalAmountsCovered() {
        return additionalAmountsCovered;
    }

    public void setAdditionalAmountsCovered(String additionalAmountsCovered) {
        this.additionalAmountsCovered = additionalAmountsCovered;
    }



    public String getMixedPaymentDetails() {
        return mixedPaymentDetails;
    }

    public void setMixedPaymentDetails(String mixedPaymentDetails) {
        this.mixedPaymentDetails = mixedPaymentDetails;
    }

    public String getNegotiationDeferredPaymentDetails() {
        return negotiationDeferredPaymentDetails;
    }

    public void setNegotiationDeferredPaymentDetails(String negotiationDeferredPaymentDetails) {
        this.negotiationDeferredPaymentDetails = negotiationDeferredPaymentDetails;
    }

    public String getPartialShipments() {
        return partialShipments;
    }

    public void setPartialShipments(String partialShipments) {
        this.partialShipments = partialShipments;
    }

    public String getTranshipment() {
        return transhipment;
    }

    public void setTranshipment(String transhipment) {
        this.transhipment = transhipment;
    }

    public String getPlaceOfTakingInChargeDFPOR() {
        return placeOfTakingInChargeDFPOR;
    }

    public void setPlaceOfTakingInChargeDFPOR(String placeOfTakingInChargeDFPOR) {
        this.placeOfTakingInChargeDFPOR = placeOfTakingInChargeDFPOR;
    }

    public String getPortOfLoadingAOD() {
        return portOfLoadingAOD;
    }

    public void setPortOfLoadingAOD(String portOfLoadingAOD) {
        this.portOfLoadingAOD = portOfLoadingAOD;
    }

    public String getPortOfDischargeAOD() {
        return portOfDischargeAOD;
    }

    public void setPortOfDischargeAOD(String portOfDischargeAOD) {
        this.portOfDischargeAOD = portOfDischargeAOD;
    }

    public String getPlaceOfFinalDestinationFTTPOD() {
        return placeOfFinalDestinationFTTPOD;
    }

    public void setPlaceOfFinalDestinationFTTPOD(String placeOfFinalDestinationFTTPOD) {
        this.placeOfFinalDestinationFTTPOD = placeOfFinalDestinationFTTPOD;
    }

    public String getLatestDateOfShipment() {
        return latestDateOfShipment;
    }

    public void setLatestDateOfShipment(String latestDateOfShipment) {
        this.latestDateOfShipment = latestDateOfShipment;
    }

    public String getShipmentPeriod() {
        return shipmentPeriod;
    }

    public void setShipmentPeriod(String shipmentPeriod) {
        this.shipmentPeriod = shipmentPeriod;
    }

    public String getDescriptionOfGoodsAndOS() {
        return descriptionOfGoodsAndOS;
    }

    public void setDescriptionOfGoodsAndOS(String descriptionOfGoodsAndOS) {
        this.descriptionOfGoodsAndOS = descriptionOfGoodsAndOS;
    }

    public String getDocumentsRequired() {
        return documentsRequired;
    }

    public void setDocumentsRequired(String documentsRequired) {
        this.documentsRequired = documentsRequired;
    }

    public String getAdditionalConditions() {
        return additionalConditions;
    }

    public void setAdditionalConditions(String additionalConditions) {
        this.additionalConditions = additionalConditions;
    }

    public String getSpecialPaymentConditionsForBeneficiary() {
        return specialPaymentConditionsForBeneficiary;
    }

    public void setSpecialPaymentConditionsForBeneficiary(String specialPaymentConditionsForBeneficiary) {
        this.specialPaymentConditionsForBeneficiary = specialPaymentConditionsForBeneficiary;
    }

    public String getSpecialPaymentConditionsForBankOnly() {
        return specialPaymentConditionsForBankOnly;
    }

    public void setSpecialPaymentConditionsForBankOnly(String specialPaymentConditionsForBankOnly) {
        this.specialPaymentConditionsForBankOnly = specialPaymentConditionsForBankOnly;
    }

    public String getCharges() {
        return charges;
    }

    public void setCharges(String charges) {
        this.charges = charges;
    }

    public ActnoBicAdrTagXXX getIssuingBank() {
        return issuingBank;
    }

    public void setIssuingBank(ActnoBicAdrTagXXX issuingBank) {
        this.issuingBank = issuingBank;
    }

    public ActnoBicAdrTagXXX getBeneficiary() {
        return beneficiary;
    }

    public void setBeneficiary(ActnoBicAdrTagXXX beneficiary) {
        this.beneficiary = beneficiary;
    }

    public DcDateCurAmtTagXXX getIncreaseOfDocumentaryCreditAmount() {
        return increaseOfDocumentaryCreditAmount;
    }

    public void setIncreaseOfDocumentaryCreditAmount(DcDateCurAmtTagXXX increaseOfDocumentaryCreditAmount) {
        this.increaseOfDocumentaryCreditAmount = increaseOfDocumentaryCreditAmount;
    }

    public DcDateCurAmtTagXXX getDecreaseOfDocumentaryCreditAmount() {
        return decreaseOfDocumentaryCreditAmount;
    }

    public void setDecreaseOfDocumentaryCreditAmount(DcDateCurAmtTagXXX decreaseOfDocumentaryCreditAmount) {
        this.decreaseOfDocumentaryCreditAmount = decreaseOfDocumentaryCreditAmount;
    }

    public ActnoBicAdrTagXXX getAvailableWithBy() {
        return availableWithBy;
    }

    public void setAvailableWithBy(ActnoBicAdrTagXXX availableWithBy) {
        this.availableWithBy = availableWithBy;
    }

    public String getDraftsAt() {
        return draftsAt;
    }

    public void setDraftsAt(String draftsAt) {
        this.draftsAt = draftsAt;
    }

    public ActnoBicAdrTagXXX getDrawee() {
        return drawee;
    }

    public void setDrawee(ActnoBicAdrTagXXX drawee) {
        this.drawee = drawee;
    }

    public ActnoBicAdrTagXXX getAmendmentChargePayableBy() {
        return amendmentChargePayableBy;
    }

    public void setAmendmentChargePayableBy(ActnoBicAdrTagXXX amendmentChargePayableBy) {
        this.amendmentChargePayableBy = amendmentChargePayableBy;
    }

    public String getPeriodForPresentationInDays() {
        return periodForPresentationInDays;
    }

    public void setPeriodForPresentationInDays(String periodForPresentationInDays) {
        this.periodForPresentationInDays = periodForPresentationInDays;
    }

    public String getConfirmationInstructions() {
        return confirmationInstructions;
    }

    public void setConfirmationInstructions(String confirmationInstructions) {
        this.confirmationInstructions = confirmationInstructions;
    }

    public ActnoBicAdrTagXXX getRequestedConfirmationParty() {
        return requestedConfirmationParty;
    }

    public void setRequestedConfirmationParty(ActnoBicAdrTagXXX requestedConfirmationParty) {
        this.requestedConfirmationParty = requestedConfirmationParty;
    }

    public ActnoBicAdrTagXXX getReimbursingBank() {
        return reimbursingBank;
    }

    public void setReimbursingBank(ActnoBicAdrTagXXX reimbursingBank) {
        this.reimbursingBank = reimbursingBank;
    }

    public String getInstructionsToThePayingANB() {
        return instructionsToThePayingANB;
    }

    public void setInstructionsToThePayingANB(String instructionsToThePayingANB) {
        this.instructionsToThePayingANB = instructionsToThePayingANB;
    }

    public ActnoBicAdrTagXXX getAdviseThroughBank() {
        return adviseThroughBank;
    }

    public void setAdviseThroughBank(ActnoBicAdrTagXXX adviseThroughBank) {
        this.adviseThroughBank = adviseThroughBank;
    }

    public String getSenderToReceiverInformation() {
        return senderToReceiverInformation;
    }

    public void setSenderToReceiverInformation(String senderToReceiverInformation) {
        this.senderToReceiverInformation = senderToReceiverInformation;
    }

    public MT707Creator(String msgType) {
        super(msgType);
    }

    public MT707Creator() {
        super("707");
    }

    /**
     * 需要编写组装报文逻辑，调用set方法即可
     *
     * @return
     */
    public void pack() {
        //MtResult mtResult = new MtResult();
        List<AbsTagCreate> tagCreateList = new ArrayList<>();
        try {
            tagCreateList.add(new Tag27Creator(this));
            tagCreateList.add(new Tag20Creator(this));
            tagCreateList.add(new Tag21Creator(this));
            tagCreateList.add(new Tag23Creator(this));
            tagCreateList.add(new Tag52aCreator(this));
            tagCreateList.add(new Tag50BCreator(this));
            tagCreateList.add(new Tag31CCreator(this));
            tagCreateList.add(new Tag26ECreator(this));
            tagCreateList.add(new Tag30Creator(this));
            tagCreateList.add(new Tag22ACreator(this));
            tagCreateList.add(new Tag23SCreator(this));
            tagCreateList.add(new Tag40ACreator(this));
            tagCreateList.add(new Tag40ECreator(this));
            tagCreateList.add(new Tag31DCreator(this));
            tagCreateList.add(new Tag50Creator(this));
            tagCreateList.add(new Tag59Creator(this));
            tagCreateList.add(new Tag32BCreator(this));
            tagCreateList.add(new Tag33BCreator(this));
            tagCreateList.add(new Tag39ACreator(this));
            tagCreateList.add(new Tag39CCreator(this));
            tagCreateList.add(new Tag41aCreator(this));
            tagCreateList.add(new Tag42CCreator(this));
            tagCreateList.add(new Tag42aCreator(this));
            tagCreateList.add(new Tag42MCreator(this));
            tagCreateList.add(new Tag42PCreator(this));
            tagCreateList.add(new Tag43PCreator(this));
            tagCreateList.add(new Tag43TCreator(this));
            tagCreateList.add(new Tag44ACreator(this));
            tagCreateList.add(new Tag44ECreator(this));
            tagCreateList.add(new Tag44FCreator(this));
            tagCreateList.add(new Tag44BCreator(this));
            tagCreateList.add(new Tag44CCreator(this));
            tagCreateList.add(new Tag44DCreator(this));
            tagCreateList.add(new Tag45BCreator(this));
            tagCreateList.add(new Tag46BCreator(this));
            tagCreateList.add(new Tag47BCreator(this));
            tagCreateList.add(new Tag49MCreator(this));
            tagCreateList.add(new Tag49NCreator(this));
            tagCreateList.add(new Tag71DCreator(this));
            tagCreateList.add(new Tag71NCreator(this));
            tagCreateList.add(new Tag48Creator(this));
            tagCreateList.add(new Tag49Creator(this));
            tagCreateList.add(new Tag58aCreator(this));
            tagCreateList.add(new Tag53aCreator(this));
            tagCreateList.add(new Tag78Creator(this));
            tagCreateList.add(new Tag57aCreator(this));
            tagCreateList.add(new Tag72ZCreator(this));
            dealTags(tagCreateList);

            mtResult.setMessage(abstractMT.message());
        } catch (Exception e) {
            e.printStackTrace();
            mtResult.setSuccess(false);
            mtResult.addDescription(e.getLocalizedMessage());
        }
        // return mtResult;
    }

    public MtResult unpack() {
        return null;
    }
}
